/*------------------------------------------------------
|              ZLSOUND.cpp
|        ZLSOUNDض
|           (c)  mochsh, 2004
--------------------------------------------------------*/

#include <dsound.h>
#include "CXDSD.h"

ZLSOUND CXDSD::Sound;
DWORD CXDSD::staticCount;
DWORD CXDSD::streamCount;
BOOL CXDSD::Initted;
HWND CXDSD::hWnd;

/***************************************************************
* : ZLSOUND(...)
*   : 캯
*             (c)  mochsh, 2004
****************************************************************/
ZLSOUND::ZLSOUND( DWORD dwNum, DWORD dwCL )
{
    lpDSound     = NULL;
    bSoundAble   = FALSE;
    dwCoopLevel  = dwCL;
    if( dwCoopLevel == DSSCL_NORMAL )
        bSetPrimaryFormat = FALSE;
    else 
        bSetPrimaryFormat = TRUE;

    // Ϊ̬ݿٿռ,ÿԪ
    ppBuffer = new LPDIRECTSOUNDBUFFER[dwNum];
    ZeroMemory( ppBuffer, dwNum*sizeof(LPDIRECTSOUNDBUFFER) );
    // Ĭϵľ̬ĴСΪ1M
    dwMaxBytesStatic = 1024000;
    dwNumStatics  = dwNum;

    // Ϊʽٿռ,ÿԪ
    // Ĭֻܴ2ʽ
    ppStream = new LPSTREAMDESC[2];
    ZeroMemory( ppStream, 2*sizeof(LPSTREAMDESC) );
    // ĬϵʽĴСΪ1M
    dwMaxBytesStream = 1024000;
    dwNumStreams = 2;
}

/***************************************************************
* : ZLSOUND(...)
*   : 캯
*             (c)  mochsh, 2004
****************************************************************/
ZLSOUND::ZLSOUND( void )
{
    lpDSound            = NULL;
    bSoundAble          = FALSE;
    // ĬЭȼһȼ,ܸıʽ
    dwCoopLevel         = DSSCL_NORMAL;
    bSetPrimaryFormat   = FALSE;

    // Ϊ̬ٿռ,ÿԪ
    // Ĭֻܴ5̬μ
    ppBuffer      = new LPDIRECTSOUNDBUFFER[5];
    ZeroMemory( ppBuffer, 5*sizeof( LPDIRECTSOUNDBUFFER ) );
    // Ĭϵľ̬ĴСΪ1M
    dwMaxBytesStatic = 1024000;
    // Ĭֻܴ5̬μ
    dwNumStatics        = 5;

    // Ϊʽٿռ,ÿԪ
    // Ĭֻܴ2ʽ
    ppStream = new LPSTREAMDESC[2];
    ZeroMemory( ppStream, 2*sizeof(LPSTREAMDESC) );
    // ĬϵʽĴСΪ1M
    dwMaxBytesStream = 1024000;
    dwNumStreams = 2;
}

/***************************************************************
* : ~ZLSOUND(...)
*   : 
*             (c)  mochsh, 2004
****************************************************************/
ZLSOUND::~ZLSOUND()
{
    // ͷž̬μռ
    if( ppBuffer )  {
        delete[] ppBuffer;
        ppBuffer  = NULL;
    }
    // ͷʽμռ
    if( ppStream ) {
        for (DWORD dw=0; dw< dwNumStreams; dw++ )
        {
            if(ppStream[dw]) {
                delete ppStream[dw];
                ppStream[dw] = NULL;
            }
        }
        delete[] ppStream;
        ppStream = NULL;
    }
    // ͷDirectSound
    ReleaseDSound();
}

/***************************************************************
* : Set_dwCoopLevel(...)
*   : DirectSoundЭȼ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::Set_dwCoopLevel( DWORD dwCL )
{
    dwCoopLevel = dwCL;
    if( dwCoopLevel == DSSCL_NORMAL )
        bSetPrimaryFormat = FALSE;
    else 
        bSetPrimaryFormat = TRUE;
}

/***************************************************************
* : Set_bSetPrimaryFormat(...)
*   : DirectSoundǷʽ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::Set_bSetPrimaryFormat( BOOL bSetFormat )
{
    if( bSetFormat )
    {
        dwCoopLevel       = DSSCL_PRIORITY;
        bSetPrimaryFormat = TRUE;
    }
    else {
        dwCoopLevel       = DSSCL_NORMAL;
        bSetPrimaryFormat = FALSE;
    }
}

/***************************************************************
* : InitDSound(...)
*   : ʼDirectSound
*             (c)  mochsh, 2004
****************************************************************/
BOOL ZLSOUND::InitDSound( HWND hWnd )
{
    // ͷǰѾ˵DirectSound
    ReleaseDSound();

	// DirectSound
    HRESULT hr = DirectSoundCreate8( NULL, &lpDSound, NULL );
	if( FAILED( hr ) )
	{
        MessageBox( hWnd, TEXT("DirectSoundʧ\n")
                          TEXT("޷\n"),
                          TEXT("DirectSoundCreate8"), MB_OK );
		return FALSE;
	}

	// DirectSoundЭȼ
    hr = lpDSound->SetCooperativeLevel(hWnd,dwCoopLevel);
	if( FAILED( hr ) )
	{
        MessageBox( hWnd, TEXT("DirectSoundЭȼʧ\n")
                          TEXT("޷\n"),
                          TEXT("SetCooperativeLevel"), MB_OK );
		return FALSE;
	}

    // ʼɹ
    bSoundAble = TRUE;
	return TRUE; 
}

/***************************************************************
* : SetPrimaryBufferFormat(...)
*   : ʽ
*             (c)  mochsh, 2004
****************************************************************/
BOOL ZLSOUND::SetPrimaryBufferFormat( DWORD dwChannels,
                                      DWORD dwSamplesPerSec,
                                      DWORD dwBitsPerSample)
{
    // Эȼʽ豸Ч򷵻
    if( !bSetPrimaryFormat||!bSoundAble )
        return FALSE;

    HRESULT  hr;
    // ʱָ
    LPDIRECTSOUNDBUFFER lpPrimaryBuffer = NULL;

    //  DSBUFFERDESC ṹ
    DSBUFFERDESC	dsbd;
	ZeroMemory( &dsbd, sizeof(dsbd) );
    dsbd.dwSize         = sizeof(DSBUFFERDESC);
    dsbd.dwFlags        = DSBCAPS_PRIMARYBUFFER;
    dsbd.dwBufferBytes  = 0; 
    dsbd.lpwfxFormat    = NULL;
    // ʱ
    hr = lpDSound->CreateSoundBuffer( &dsbd, &lpPrimaryBuffer, NULL );
	if( FAILED( hr ) )
        return FALSE;

    // waveʽṹ
	WAVEFORMATEX	wfx;
	ZeroMemory( &wfx, sizeof(wfx) );
    wfx.wFormatTag      = WAVE_FORMAT_PCM;
    wfx.nChannels       = (WORD)dwChannels;
    wfx.nSamplesPerSec  = dwSamplesPerSec;
    wfx.wBitsPerSample  = (WORD)dwBitsPerSample;
    wfx.nBlockAlign     = wfx.wBitsPerSample / 8 * wfx.nChannels;
    wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;

    // wfxṹֵʽ
    hr = lpPrimaryBuffer->SetFormat( &wfx );
	if( FAILED( hr ) )
        return FALSE;

    // ͷʱ
    if( lpPrimaryBuffer )
    {
        lpPrimaryBuffer->Release();
        lpPrimaryBuffer = NULL;
    }

    return TRUE;
}

/***************************************************************
* : ReleaseDSound(...)
*   : ͷDirectSound
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::ReleaseDSound(void)
{
	if( lpDSound != NULL )
	{
		lpDSound->Release();
		lpDSound = NULL;
	}
}

/***************************************************************
* : RestoreBuffer(...)
*   : ָָĻռ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::RestoreBuffer( LPDIRECTSOUNDBUFFER lpBuf )
{
    HRESULT hr;
    if( lpBuf )
    {
        hr = lpBuf->Restore();
        while( hr == DSBSTATUS_BUFFERLOST )
            lpBuf->Restore();
    }
}

/***************************************************************
* : LoadWaveFile(...)
*   : ȡļ
*   ע: bReadDataֵΪʱһpDataָָ
*         ݻʹúͷ
*             (c)  mochsh, 2004
****************************************************************/
BYTE * ZLSOUND::LoadWaveFile( WAVEFORMATEX  *format,
                              DWORD         *pdwDataLen,
                              LPCSTR        filename,
                              BOOL          bReadData)
{
	if( filename==NULL )
		return NULL;

	// ֻģʽWAVEļ
	HMMIO file = mmioOpen((LPSTR)filename,NULL,MMIO_READ);
	if( file==NULL )
		return NULL;

	// жϸļǷΪ"WAVE"ļʽ
	char ch[4];
	mmioSeek( file, 8L, SEEK_SET );
	mmioRead( file, ch, 4L );
    if(ch[0]!='W'||ch[1]!='A'||ch[2]!='V'||ch[3]!='E')
	{
		mmioClose( file, 0 );
		return NULL;
	}

	// ȡWAVEļWAVEFORMATEXṹ
	if( format )
	{
		mmioSeek( file, 20L, SEEK_SET );
		mmioRead( file, (HPSTR)format, sizeof(WAVEFORMATEX) );
	}

    // ȡݵĳ
    DWORD dwDataLen;
    mmioSeek( file, 40L, SEEK_SET );
    mmioRead( file, (char*)&dwDataLen, sizeof(DWORD) );

    // ǷҪ¼ݵĳ
    if( pdwDataLen )
        (*pdwDataLen) = dwDataLen;

    // Ƿȡ
    BYTE *pData = NULL;
    if( bReadData )
    {
        // һݵĿռ
        pData = new BYTE[ dwDataLen ];
        // ȡ
        mmioSeek( file, 44L, SEEK_SET );
        mmioRead( file, (char*)pData, (LONG)dwDataLen );
    }

    mmioClose( file, 0);
	return pData;
}

/***************************************************************
* : Set_dwNumStatics(...)
*   : ZLSOUNDɴľ̬μĿ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::Set_dwNumStatics( DWORD dwNum )
{
    // ôμĸڴDirectSound֮ǰ
    if( lpDSound )
        return;

    // ͷǰĿռ
    if( ppBuffer )  {
        delete[] ppBuffer;
        ppBuffer  = NULL;
    }

    // µĿռ
    ppBuffer = new LPDIRECTSOUNDBUFFER[dwNum];
    // 
    ZeroMemory( ppBuffer, dwNum*sizeof(LPDIRECTSOUNDBUFFER) );
    dwNumStatics = dwNum;
}

/***************************************************************
* : CreateStaticBuffer(...)
*   : һμ,ҽfilenameָ
*         û
*             (c)  mochsh, 2004
****************************************************************/
BOOL ZLSOUND::CreateStaticBuffer( DWORD dwIndex, LPCSTR filename )
{
    // Ч
    if( !bSoundAble )             return FALSE;
    if( dwIndex >= dwNumStatics ) return FALSE;
    if( ppBuffer == NULL )        return FALSE;

    HRESULT hr;
	BYTE *pData; 		//ʱݻָ
	WAVEFORMATEX format;//ݵĸʽ
	DWORD dwDataLen;	//ݴС

    // ע: LoadWaveFileһpDataָĿռ,Ҫͷ
	pData = LoadWaveFile( &format, &dwDataLen, filename, TRUE );

	if( pData == NULL )
        return FALSE ;

    // ޶ĴС
    if( dwDataLen > dwMaxBytesStatic )
        dwDataLen = dwMaxBytesStatic;

    //  DSBUFFERDESC ṹ,ҸݸԴμ̬
	DSBUFFERDESC dsbd;
	ZeroMemory( &dsbd, sizeof(dsbd) );
	dsbd.dwSize		   = sizeof(dsbd);
	dsbd.dwFlags	   = DSBCAPS_CTRLFREQUENCY | DSBCAPS_CTRLPAN |	
					     DSBCAPS_CTRLVOLUME | DSBCAPS_STATIC;
	dsbd.dwBufferBytes = dwDataLen;
	dsbd.lpwfxFormat   = &format;
	hr = lpDSound->CreateSoundBuffer(&dsbd,&ppBuffer[dwIndex],NULL);
	if( FAILED( hr ))  {
		delete[] pData;
        return FALSE;
	}

	LPVOID lpvPtr;
	DWORD dwBytes;

    // Աд
	hr = ppBuffer[dwIndex]->Lock(0,0,&lpvPtr,&dwBytes,NULL,NULL,
                                 DSBLOCK_ENTIREBUFFER);
	if( FAILED(hr) ) {
        RestoreBuffer( ppBuffer[dwIndex] );
        delete[] pData;
        return FALSE;
    }

    // ݴݵ
	memcpy( lpvPtr, pData, dwBytes );

    // 
    hr = ppBuffer[dwIndex]->Unlock( lpvPtr, dwBytes, NULL, 0 );
	if( FAILED(hr) ) {
        RestoreBuffer( ppBuffer[dwIndex] );
		delete[] pData;
        return FALSE;
	}

	delete[] pData;
	return TRUE;
}

/***************************************************************
* : ReleaseStaticBuffer(...)
*   : ָĴμ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::ReleaseStaticBuffer( DWORD dwIndex )
{
    // Ч
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    ppBuffer[dwIndex]->Release();
    ppBuffer[dwIndex] = NULL;
}

/***************************************************************
* : PlayStatic(...)
*   : ž̬
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::PlayStatic( DWORD dwIndex, BOOL bLoop, BOOL bCompulsory )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    // ȡ״̬
	DWORD dwStatus;
	HRESULT hr = ppBuffer[dwIndex]->GetStatus( &dwStatus );
	if( FAILED( hr ) )
        return;

    // ʧ˻»
    if( dwStatus & DSBSTATUS_BUFFERLOST )
    {
        RestoreBuffer( ppBuffer[dwIndex] );
        return;
    }

    // ǿԴͷ
    if( !bCompulsory ) 
    {
        // Ѿ򷵻
        if( dwStatus & DSBSTATUS_PLAYING )
            return;
        // δ򲥷
        else {
            ppBuffer[dwIndex]->SetCurrentPosition(0);
		    ppBuffer[dwIndex]->Play(0,0,(bLoop?DSBPLAY_LOOPING:0));
        }
    }
    // ǿԴͷ
    else {
        ppBuffer[dwIndex]->SetCurrentPosition(0);
		ppBuffer[dwIndex]->Play(0,0,(bLoop?DSBPLAY_LOOPING:0));
    }
}

/***************************************************************
* : StopStatic(...)
*   : ֹͣž̬
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::StopStatic( DWORD dwIndex )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    ppBuffer[dwIndex]->Stop();
}

/***************************************************************
* : StaticIsPlaying(...)
*   : ̬Ƿڲ
*             (c)  mochsh, 2004
****************************************************************/
BOOL ZLSOUND::StaticIsPlaying( DWORD dwIndex )
{
    // Ч
    if( !bSoundAble )             return FALSE;
    if( dwIndex >= dwNumStatics ) return FALSE;
    if( ppBuffer == NULL )        return FALSE;
    if( ppBuffer[dwIndex]==NULL ) return FALSE;

    // ȡ״̬
	DWORD dwStatus;
	HRESULT hr = ppBuffer[dwIndex]->GetStatus( &dwStatus );
	if( FAILED( hr ) )
        return FALSE;

    // ʧ˻» 
    if( dwStatus & DSBSTATUS_BUFFERLOST )
    {
        RestoreBuffer( ppBuffer[dwIndex] );
        return FALSE;
    }
	else if( dwStatus & DSBSTATUS_PLAYING )
		return TRUE;
	else
		return FALSE;
}

/***************************************************************
* : SetStaticVolume(...)
*   : ָ̬
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SetStaticVolume( DWORD dwIndex, LONG lVolume )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    if( lVolume > DSBVOLUME_MAX )   lVolume = DSBVOLUME_MAX;
    if( lVolume < DSBVOLUME_MIN )   lVolume = DSBVOLUME_MIN;
    ppBuffer[dwIndex]->SetVolume( lVolume );
}

/***************************************************************
* : AddStaticVolume(...)
*   : ָľ̬lAddָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::AddStaticVolume( DWORD dwIndex, LONG lAdd )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    LONG  lVolume;
    if( ppBuffer[dwIndex] )
    {
        ppBuffer[dwIndex]->GetVolume( &lVolume );
        lVolume += lAdd;

        if( lVolume > DSBVOLUME_MAX )   lVolume = DSBVOLUME_MAX;
        if( lVolume < DSBVOLUME_MIN )   lVolume = DSBVOLUME_MIN;
        ppBuffer[dwIndex]->SetVolume( lVolume );
    }
}

/***************************************************************
* : SubStaticVolume(...)
*   : ָľ̬lSubָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SubStaticVolume( DWORD dwIndex, LONG lSub )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    LONG  lVolume;
    if( ppBuffer[dwIndex] )
    {
        ppBuffer[dwIndex]->GetVolume( &lVolume );
        lVolume -= lSub;

        if( lVolume > DSBVOLUME_MAX )   lVolume = DSBVOLUME_MAX;
        if( lVolume < DSBVOLUME_MIN )   lVolume = DSBVOLUME_MIN;
        ppBuffer[dwIndex]->SetVolume( lVolume );
    }
}

/***************************************************************
* : SetStaticPan(...)
*   : ָ̬ΪlPanֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SetStaticPan( DWORD dwIndex, LONG lPan )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    if( lPan > DSBPAN_RIGHT )  lPan = DSBPAN_RIGHT;
    if( lPan < DSBPAN_LEFT  )  lPan = DSBPAN_LEFT;
    ppBuffer[dwIndex]->SetPan( lPan );
}

/***************************************************************
* : AddStaticPan(...)
*   : ָľ̬ľlAddֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::AddStaticPan( DWORD dwIndex, LONG lAdd )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    LONG  lPan;
    if( ppBuffer[dwIndex] )
    {
        ppBuffer[dwIndex]->GetPan( &lPan );
        lPan += lAdd;

        if( lPan > DSBPAN_RIGHT )  lPan = DSBPAN_RIGHT;
        if( lPan < DSBPAN_LEFT  )  lPan = DSBPAN_LEFT;
        ppBuffer[dwIndex]->SetPan( lPan );
    }
}

/***************************************************************
* : SubStaticPan(...)
*   : ָľ̬ľlSubֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SubStaticPan( DWORD dwIndex, LONG lSub )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    LONG  lPan;
    if( ppBuffer[dwIndex] )
    {
        ppBuffer[dwIndex]->GetPan( &lPan );
        lPan -= lSub;

        if( lPan > DSBPAN_RIGHT )  lPan = DSBPAN_RIGHT;
        if( lPan < DSBPAN_LEFT  )  lPan = DSBPAN_LEFT;
        ppBuffer[dwIndex]->SetPan( lPan );
    }
}

/***************************************************************
* : SetStaticFreq(...)
*   : ָ̬ƵΪdwFreqֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SetStaticFreq( DWORD dwIndex, DWORD dwFreq )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    // ƵʷΧΪԭʼƵ
    if( dwFreq < DSBFREQUENCY_MIN || dwFreq > DSBFREQUENCY_MAX )
        dwFreq = DSBFREQUENCY_ORIGINAL;
    ppBuffer[dwIndex]->SetFrequency( dwFreq );
}

/***************************************************************
* : AddStaticFreq(...)
*   : ָľ̬ƵdwAddֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::AddStaticFreq( DWORD dwIndex, DWORD dwAdd )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    DWORD dwFreq;
    if( ppBuffer[dwIndex] )
    {
        ppBuffer[dwIndex]->GetFrequency( &dwFreq );
        dwFreq += dwAdd;

        if( dwFreq < DSBFREQUENCY_MIN ) dwFreq = DSBFREQUENCY_MIN;
        if( dwFreq > DSBFREQUENCY_MAX ) dwFreq = DSBFREQUENCY_MAX;
        ppBuffer[dwIndex]->SetFrequency( dwFreq );
    }
}

/***************************************************************
* : SubStaticFreq(...)
*   : ָľ̬ƵʽdwSubֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SubStaticFreq( DWORD dwIndex, DWORD dwSub )
{
    // Ч
    if( !bSoundAble )             return;
    if( dwIndex >= dwNumStatics ) return;
    if( ppBuffer == NULL )        return;
    if( ppBuffer[dwIndex]==NULL ) return;

    DWORD dwFreq;
    if( ppBuffer[dwIndex] )
    {
        ppBuffer[dwIndex]->GetFrequency( &dwFreq );
        dwFreq -= dwSub;

        if( dwFreq < DSBFREQUENCY_MIN ) dwFreq = DSBFREQUENCY_MIN;
        if( dwFreq > DSBFREQUENCY_MAX ) dwFreq = DSBFREQUENCY_MAX;
        ppBuffer[dwIndex]->SetFrequency( dwFreq );
    }
}

/***************************************************************
* : Get_pStaticBuffer(...)
*   : ȡָľָ̬
*             (c)  mochsh, 2004
****************************************************************/
LPDIRECTSOUNDBUFFER ZLSOUND::Get_pStaticBuffer( DWORD dwIndex )
{
    // Ч
    if( dwIndex >= dwNumStatics ) return NULL;
    if( ppBuffer == NULL )        return NULL;

    return ppBuffer[dwIndex];
}

/***************************************************************
* : Set_dwNumStreams(...)
*   : ZLSOUNDɴʽμĿ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::Set_dwNumStreams( DWORD dwNum )
{
    // ôμĸڴDirectSound֮ǰ
    if( lpDSound )
        return;

    // ͷǰʽμռ
    if( ppStream ) {
        for (DWORD dw=0; dw< dwNumStreams; dw++ )
        {
            if(ppStream[dw]) {
                delete ppStream[dw];
                ppStream[dw] = NULL;
            }
        }
        delete[] ppStream;
        ppStream = NULL;
    }

    // µĸµĿռ䣬
    ppStream = new LPSTREAMDESC[dwNum];
    ZeroMemory( ppStream, dwNum*sizeof(LPSTREAMDESC) );
    dwNumStreams = dwNum;
}

/***************************************************************
* : CreateStreamBuffer(...)
*   : һʽ,ָļݵ
*         ͷһ뻺
*             (c)  mochsh, 2004
****************************************************************/
BOOL ZLSOUND::CreateStreamBuffer( DWORD dwIndex, LPCSTR filename )
{
    // Ч
    if( !bSoundAble )             return FALSE;
    if( dwIndex >= dwNumStreams ) return FALSE;
    if( ppStream == NULL )        return FALSE;

    ppStream[dwIndex] = new STREAMDESC;
    ZeroMemory( ppStream[dwIndex],sizeof(STREAMDESC) );
    ppStream[dwIndex]->filename = filename;

    // ȡļϢ
	LoadWaveFile( &ppStream[dwIndex]->wfx,
                  (DWORD*)&ppStream[dwIndex]->lDataLen,
                  ppStream[dwIndex]->filename, FALSE );
    if(ppStream[dwIndex]->lDataLen==0) {
        delete ppStream[dwIndex];
        ppStream[dwIndex] = NULL;
        return FALSE;
    }

    // ޶ĴС
    if( ppStream[dwIndex]->lDataLen > (LONG)dwMaxBytesStream )
    {
        ppStream[dwIndex]->lBufSize      = (LONG)dwMaxBytesStream;
        ppStream[dwIndex]->bStaticBuffer = FALSE;
    }
    else {
        ppStream[dwIndex]->lBufSize   = ppStream[dwIndex]->lDataLen;
        ppStream[dwIndex]->bStaticBuffer = TRUE;
    }

    HRESULT hr;
    //  DSBUFFERDESC ṹ,ҸݸԴ
	DSBUFFERDESC dsbd;
	ZeroMemory( &dsbd, sizeof(dsbd) );
	dsbd.dwSize		   = sizeof(dsbd);
	dsbd.dwFlags	   = DSBCAPS_CTRLFREQUENCY | DSBCAPS_CTRLPAN |	
					     DSBCAPS_CTRLVOLUME ;
	dsbd.dwBufferBytes = (DWORD)ppStream[dwIndex]->lBufSize;
	dsbd.lpwfxFormat   = &ppStream[dwIndex]->wfx;
	hr = lpDSound->CreateSoundBuffer( &dsbd,
                                      &ppStream[dwIndex]->lpBuffer,
                                      NULL);
    if( FAILED( hr )) {
        delete ppStream[dwIndex];
        ppStream[dwIndex] = NULL;
        return FALSE;
    }

    // Waveļʱϵĳ(Ϊλ)
    ppStream[dwIndex]->lSecondsLen = (LONG) (
        ppStream[dwIndex]->lDataLen /
        ppStream[dwIndex]->wfx.nAvgBytesPerSec );
    // 㻺һʱ䳤(ԺΪλ)
    ppStream[dwIndex]->lMillisecsHalfBuf =(LONG)(
        (FLOAT)ppStream[dwIndex]->lBufSize * 500.0F/
        (FLOAT)ppStream[dwIndex]->wfx.nAvgBytesPerSec );

    // ʼʽĸֲ
    ppStream[dwIndex]->lBufPos  = 0;
    ppStream[dwIndex]->lBufSection = 0;
    ppStream[dwIndex]->lDataPos = 0;
    ppStream[dwIndex]->lReadLen = ppStream[dwIndex]->lBufSize;
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lReadLen = (LONG)(ppStream[dwIndex]->lBufSize/2);

    return TRUE;
}

/***************************************************************
* : ClearStreamBuffer(...)
*   : ָʽ,Ϊ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::ClearStreamBuffer( DWORD dwIndex )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    //>>>>>>>>>>>> д >>>>>>>>>>>>>>>
	LPVOID lpvPtr;
	DWORD dwBytes;
    HRESULT hr;

    // Աд
	hr = ppStream[dwIndex]->lpBuffer->Lock( 0,0,
                                            &lpvPtr, &dwBytes,
                                            NULL, NULL,
                                            DSBLOCK_ENTIREBUFFER);
	if( FAILED(hr) ) {
        RestoreBuffer( ppStream[dwIndex]->lpBuffer );
        return;
    }

    // ݴݵ
    ZeroMemory( lpvPtr, dwBytes );

    // 
    hr = ppStream[dwIndex]->lpBuffer->Unlock( lpvPtr, dwBytes,
                                              NULL, 0 );
	if( FAILED(hr) ) {
        RestoreBuffer( ppStream[dwIndex]->lpBuffer );
        return;
	}
}

/***************************************************************
* : ReleaseStreamBuffer(...)
*   : ͷָʽĿռ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::ReleaseStreamBuffer( DWORD dwIndex )
{
    // Ч
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    ppStream[dwIndex]->lpBuffer->Release();
    ppStream[dwIndex]->lpBuffer = NULL;

    delete ppStream[dwIndex];
    ppStream[dwIndex] = NULL;
}

/***************************************************************
* : PlayStream(...)
*   : ָķʽָʽ
*     ע: ñʱֻеﵽ»ͷֻ
*         βֵݵ󣬲Żļȡݡ
*         ÿδļȡݺļݵĲαԶ
*         ƣѭļαԶơ
*         ǰδļȡݵʱʽ
*         ԱlMillisecsHalfBuf
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::PlayStream( DWORD dwIndex, BOOL bLoop )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    HRESULT hr;
    // ȡĿǰ״̬
	DWORD dwStatus; 
	hr = ppStream[dwIndex]->lpBuffer->GetStatus(&dwStatus);
	if( FAILED( hr ) )
        return;

    // ʧ˻»ȡ
    if( dwStatus & DSBSTATUS_BUFFERLOST )
    {
        RestoreBuffer( ppStream[dwIndex]->lpBuffer );
        return;
    }

    //>>>>> ԴݵĴССڻĴС,ʵ־̬ >>>>>>
    if( ppStream[dwIndex]->bStaticBuffer )
    {
        // Ѿ򷵻
        if( dwStatus & DSBSTATUS_PLAYING )
            return;
        // δ򲥷
        else {
            ppStream[dwIndex]->lpBuffer->SetCurrentPosition(0);
            ppStream[dwIndex]->lpBuffer->Play(
                        0,0,(bLoop?DSBPLAY_LOOPING:0));
        }
        return;
    }
    //>>>>>>>>>>> ʽ >>>>>>>>>>>>>>>
    // ڲ
    if( dwStatus & DSBSTATUS_PLAYING )
    {
        ppStream[dwIndex]->lpBuffer->GetCurrentPosition(
                    (LPDWORD)&ppStream[dwIndex]->lBufPos,NULL );
        if(ppStream[dwIndex]->lBufPos >= ppStream[dwIndex]->lReadLen)
        {
            // α굽ﻺм,¿ͷ
            if( ppStream[dwIndex]->lBufSection==0 ) 
            {
                UpdateStreamBuffer( dwIndex );
                ppStream[dwIndex]->lBufSection = 1;
            }
        }
        // α굽ﻺĽ(Ҳǿʼ),½β
        else if( ppStream[dwIndex]->lBufSection==1 )
        {
            UpdateStreamBuffer( dwIndex );
            ppStream[dwIndex]->lBufSection = 0;
        }
    }
    // ʼ
    else {
        ppStream[dwIndex]->lpBuffer->SetCurrentPosition(0);
        ppStream[dwIndex]->bLoop = bLoop;
        ppStream[dwIndex]->lpBuffer->Play(0,0,1);
    }
}

/***************************************************************
* : PauseStream(...)
*   : ָͣʽļȡ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::PauseStream( DWORD dwIndex )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    ppStream[dwIndex]->lpBuffer->Stop();
}

/***************************************************************
* : StopStream(...)
*   : ֹͣʽĲţļݵ
*         αڿͷȻļݵĿͷ
*         뻺ԣStopStreamһļ
*         ȡһΣʹʱҪƵʹStopStream
*         ʱ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::StopStream( DWORD dwIndex )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    ppStream[dwIndex]->lpBuffer->Stop();
    ppStream[dwIndex]->lBufPos      = 0;
    ppStream[dwIndex]->lBufSection  = 0;
    ppStream[dwIndex]->lDataPos     = 0;

    // ¸ǰλ
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection  = 1;
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection  = 0;
}

/***************************************************************
* : SetStreamPos(...)
*   : ָʽĲαΪlPosָλ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SetStreamPos( DWORD dwIndex, LONG lPos )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    // ͣʽ
    PauseStream( dwIndex );

    LONG Pos = ppStream[dwIndex]->wfx.nAvgBytesPerSec * lPos;
    ppStream[dwIndex]->lDataPos = Pos;

    // αصĿʼλ
    ppStream[dwIndex]->lBufPos = 0;
    ppStream[dwIndex]->lBufSection = 0;

    // ޶αλ
    if( ppStream[dwIndex]->lDataPos >= ppStream[dwIndex]->lDataLen )
        ppStream[dwIndex]->lDataPos = ppStream[dwIndex]->lDataLen-1;
    else if( ppStream[dwIndex]->lDataPos < 0 )
        ppStream[dwIndex]->lDataPos = 0;

    // ¸»ǰε
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection = 1;
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection = 0;
}

/***************************************************************
* : AddStreamPos(...)
*   : ָʽĲαλlAddֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::AddStreamPos( DWORD dwIndex, LONG lAdd )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    // ͣʽ
    PauseStream( dwIndex );

    LONG Add = ppStream[dwIndex]->wfx.nAvgBytesPerSec * lAdd;
    ppStream[dwIndex]->lDataPos += Add;

    // αصĿʼλ
    ppStream[dwIndex]->lBufPos = 0;
    ppStream[dwIndex]->lBufSection = 0;

    // ޶αλ
    if( ppStream[dwIndex]->lDataPos >= ppStream[dwIndex]->lDataLen )
        ppStream[dwIndex]->lDataPos = ppStream[dwIndex]->lDataLen;

    // ¸»ǰֵ
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection = 1;
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection = 0;
}

/***************************************************************
* : SubStreamPos(...)
*   : ָʽļݵĲαλúlSubֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SubStreamPos( DWORD dwIndex, LONG lSub )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    // ͣʽ
    PauseStream( dwIndex );

    LONG Sub = ppStream[dwIndex]->wfx.nAvgBytesPerSec * lSub;
    ppStream[dwIndex]->lDataPos -= Sub;

    // αصĿʼλ
    ppStream[dwIndex]->lBufPos = 0;
    ppStream[dwIndex]->lBufSection = 0;

    // αλ޶
    if( ppStream[dwIndex]->lDataPos < 0 )
        ppStream[dwIndex]->lDataPos = 0;

    // »ǰε
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection = 1;
    UpdateStreamBuffer( dwIndex );
    ppStream[dwIndex]->lBufSection = 0;
}

/***************************************************************
* : AddStreamVolume(...)
*   : ָʽλlAddֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::AddStreamVolume( DWORD dwIndex, LONG lAdd )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    LONG lVolume;
    // ȡǰ
    ppStream[dwIndex]->lpBuffer->GetVolume( &lVolume );
    lVolume += lAdd;

    // ޶
    if( lVolume > DSBVOLUME_MAX )   lVolume = DSBVOLUME_MAX;
    if( lVolume < DSBVOLUME_MIN )   lVolume = DSBVOLUME_MIN;
    ppStream[dwIndex]->lpBuffer->SetVolume( lVolume );
}

/***************************************************************
* : SubStreamVolume(...)
*   : ָʽλýlSubֵָ
*             (c)  mochsh, 2004
****************************************************************/
void ZLSOUND::SubStreamVolume( DWORD dwIndex, LONG lSub )
{
    // Ч
    if( !bSoundAble )                       return;
    if( dwIndex >= dwNumStreams )           return;
    if( ppStream == NULL )                  return;
    if( ppStream[dwIndex]==NULL )           return;
    if( ppStream[dwIndex]->lpBuffer==NULL ) return;

    LONG lVolume;
    // ȡǰ
    ppStream[dwIndex]->lpBuffer->GetVolume( &lVolume );
    lVolume -= lSub;

    // ޶
    if( lVolume > DSBVOLUME_MAX )   lVolume = DSBVOLUME_MAX;
    if( lVolume < DSBVOLUME_MIN )   lVolume = DSBVOLUME_MIN;
    ppStream[dwIndex]->lpBuffer->SetVolume( lVolume );
}

/***************************************************************
* : LoadStreamData(...)
*   : ļ
*   ע: ñ󣬽һpDataָָ
*         ʹúͷ
*             (c)  mochsh, 2004
****************************************************************/
BYTE * ZLSOUND::LoadStreamData( DWORD dwIndex )
{
    // Ч
    if( !bSoundAble )               return NULL;
    if( dwIndex >= dwNumStreams )   return NULL;
    if( ppStream == NULL )          return NULL;
    if( ppStream[dwIndex] == NULL ) return NULL;
	if( ppStream[dwIndex]->lReadLen <=0 ) return NULL;

	BYTE *pData = NULL;  LONG lNext;  HMMIO file;

    // ֻʽWAVEļ
	file = mmioOpen((LPSTR)ppStream[dwIndex]->filename,
                           NULL,MMIO_READ);
    if( file==NULL ) {
        ppStream[dwIndex]->lDataLen=0;
		return NULL;
    }

	//>>>>>>>>>>>>>>>> ȡʽ >>>>>>>>>>>>>>
    // жݿԶȡ
    lNext =ppStream[dwIndex]->lDataLen -
            ppStream[dwIndex]->lDataPos;

    // һݵĿռ
    pData = new BYTE[ ppStream[dwIndex]->lReadLen ];

    // ļλĿǰλ
    mmioSeek( file, 44+ppStream[dwIndex]->lDataPos, SEEK_SET);
    // ȡ
    if( ppStream[dwIndex]->lReadLen > lNext )
    {
        mmioRead( file, (char*)pData, lNext );
        if( ppStream[dwIndex]->bLoop ) {
            // ļݵĿͷӦöȡ
            LONG lSurplus = ppStream[dwIndex]->lReadLen -lNext;
            mmioSeek( file, 44, SEEK_SET );
            mmioRead( file,(char*)(pData+lNext),lSurplus );
            // αƵļݵĿͷ
            ppStream[dwIndex]->lDataPos = lSurplus;
        }
        else
            ppStream[dwIndex]->lDataPos += lNext;
    }
    else {
        mmioRead(file,(char*)pData,ppStream[dwIndex]->lReadLen );
        // α
        ppStream[dwIndex]->lDataPos+=ppStream[dwIndex]->lReadLen;
    }

    mmioClose( file, 0 );
	return pData;
}

/********************************************************
* : UpdateStreamBuffer(...)
*   : ļȡݸʽ(ǰλ)
*             (c)  mochsh, 2004
*********************************************************/
BOOL ZLSOUND::UpdateStreamBuffer( DWORD dwIndex )
{
    // Ч
    if( !bSoundAble )                     return FALSE;
    if( dwIndex >= dwNumStreams )         return FALSE;
    if( ppStream == NULL )                return FALSE;
    if( ppStream[dwIndex]==NULL )         return FALSE;
    if( ppStream[dwIndex]->lpBuffer==NULL)return FALSE;

    HRESULT hr;
	BYTE *pData =NULL;//ʱ
    // ע: LoadStreamDataһpDataָ
    //     Ŀռ,Ҫͷ
	pData = LoadStreamData( dwIndex );
	if( pData == NULL )
        return FALSE;

    //>>>>>>>>>>>> д >>>>>>>>>>>>>>>
	LPVOID lpvPtr1, lpvPtr2;//ָ1	//ָ2
	DWORD dwBytes1, dwBytes2;
    DWORD dwOffset;
    if( ppStream[dwIndex]->lBufSection==0 )
        dwOffset = 0;
    else
        dwOffset = (DWORD)ppStream[dwIndex]->lReadLen;

    // Աд
	hr = ppStream[dwIndex]->lpBuffer->Lock( dwOffset,
                    (DWORD)ppStream[dwIndex]->lReadLen,
                    &lpvPtr1, &dwBytes1,
                    &lpvPtr2, &dwBytes2, 0);
	if( FAILED(hr) ) {
        RestoreBuffer( ppStream[dwIndex]->lpBuffer );
        delete[] pData;
        return FALSE;
    }

    // ݴݵ
	memcpy( lpvPtr1, pData, dwBytes1 );
	if( dwBytes2 )
		memcpy( lpvPtr2, pData+dwBytes1, dwBytes2 );

    // 
    hr = ppStream[dwIndex]->lpBuffer->Unlock(lpvPtr1,
                                             dwBytes1,
                                             lpvPtr2,
                                             dwBytes2 );
	if( FAILED(hr) ) {
        RestoreBuffer( ppStream[dwIndex]->lpBuffer );
		delete[] pData;
        return FALSE;
	}

	delete[] pData;
	return TRUE;
}
//*************************************

